=== debian/changelog ===
boost1.74 (1.74.0-9) unstable; urgency=medium

  [ Andreas Beckmann ]
  * libboost1.74-dev: Smoothen upgrades from buster by depending on
    libstdc++-${gxx:major}-dev using the build-time version of g++ instead of
    the virtual libstdc++-dev provided by multiple packages.
    (Closes: #984838)

 -- Anton Gladky <gladk@debian.org>  Sat, 13 Mar 2021 09:21:38 +0100

boost1.74 (1.74.0-8) unstable; urgency=medium

  * [85a2610] Fix compilation warnings. (Closes: #980497)
  * [1cd99ad] Set Standards-version to 4.5.1

 -- Anton Gladky <gladk@debian.org>  Sat, 23 Jan 2021 20:00:18 +0100

boost1.74 (1.74.0-7) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * [8b3d244] Fix ptree_serialization failing to build with boost1.74.
    (Closes: #977230)

 -- Anton Gladky <gladk@debian.org>  Mon, 04 Jan 2021 22:17:05 +0100

boost1.74 (1.74.0-6) unstable; urgency=medium

  * [25520d6] Fix detection of ASM-files for mipsel. (Closes: #977921)

 -- Anton Gladky <gladk@debian.org>  Sat, 26 Dec 2020 15:18:55 +0100

boost1.74 (1.74.0-5) unstable; urgency=medium

  [ Pino Toscano ]
  * [6a1ba93] Add a way to identify GNU/Hurd with b2. (Closes: #977414)

  [ Anton Gladky ]
  * [9569ec1] Update watch file format version to 4.

 -- Anton Gladky <gladk@debian.org>  Thu, 17 Dec 2020 21:24:03 +0100

boost1.74 (1.74.0-4) unstable; urgency=medium

  * [283f917] Fix description for nowide-library
  * [fa3c8ab] Add Breaks+Replaces: libleatherman-dev (<< 1.12.1+dfsg-1.1~)
              to libbost1.74-dev. (Closes: #977310)

 -- Anton Gladky <gladk@debian.org>  Sun, 13 Dec 2020 22:55:30 +0100

boost1.74 (1.74.0-3) unstable; urgency=medium

  * [b66a37a] Install b2. (Closes: #975446)
  * [508a668] Bump debhelper from old 10 to 12.
    + debian/rules: Rely on default use of dh_missing rather
      than using dh_install --list-missing.
  * [97c2bd1] Set debhelper-compat version in Build-Depends.
  * [e26eec0] Remove listed license files
  * [51d69a5] Drop transition for old debug package migration.
  * [076941c] Remove Section on some libs  hat duplicate source.

 -- Anton Gladky <gladk@debian.org>  Fri, 27 Nov 2020 20:37:42 +0100

boost1.74 (1.74.0-2) unstable; urgency=medium

  * [a634d58] Add libboost-nowide1.74-dev into libboost1.74-dev.
  * [c60ee8c] Allow graph, log and thread tests to output into stderr.
  * [4b70713] Remove usage of deprecated headers. (Closes: #974577)

 -- Anton Gladky <gladk@debian.org>  Tue, 17 Nov 2020 22:30:42 +0100

boost1.74 (1.74.0-1) unstable; urgency=medium

  * New upstream version.
    + Update Debian patches.
    + Update debian/copyright.
  * Fix little bugs in debian/rules.

 -- Giovanni Mascellani <gio@debian.org>  Sun, 18 Oct 2020 20:13:31 +0200

boost1.71 (1.71.0-7) unstable; urgency=medium

  * Do not install stacktrace_backtrace on m68k, where it is not built
    (closes: #962072). Thanks to Adrian Glaubitz for the patch.
  * Fix broken macOS detection, conflicting with GNU/Hurd
    (closes: #960090). Thanks to Pino Toscano for the patch.
  * Fix some lintian warnings.

 -- Giovanni Mascellani <gio@debian.org>  Mon, 12 Oct 2020 09:50:03 +0200

boost1.71 (1.71.0-6) unstable; urgency=medium

  * [ef8987f] Fix python autopkgtest. (closes: #950688)
  * [aad42c4] Trim trailing whitespace.
  * [5b9edee] Fix failing autopkgtest graph-parallel

 -- Anton Gladky <gladk@debian.org>  Tue, 04 Feb 2020 22:10:35 +0100

boost1.71 (1.71.0-5) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Cherrypick further patches to document and optimize context on
    s390x. LP: #1859941
  * Simplify debian/rules slightly, by dropping resetting the default
    values.
  * Skip building numpy on Ubuntu:i386.

  [ Giovanni Mascellani ]
  * Expose Python version information in dependencies to Python packages, so
    that removing a supported Python version does not result in silently
    broken reverse dependencies (closes: #948273). Thanks to Andreas Beckmann
    for the patch.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 30 Jan 2020 15:50:23 +0000

boost1.71 (1.71.0-4) unstable; urgency=medium

  [ Giovanni Mascellani ]
  * Transition to the Salsa CI team pipeline.
  * Enable -context on mips64el (closes: #948015).
  * Set graph-parallel test as flaky until
    https://github.com/boostorg/graph_parallel/issues/21 is resolved.
  * Compile test context/demo1.cpp only on amd64, because it uses some
    architecture specific instructions.

  [ Dimitri John Ledkov ]
  * Add chrono to thread autopkgtest until
    https://github.com/boostorg/boost_install/issues/27 is resolved.

 -- Giovanni Mascellani <gio@debian.org>  Fri, 10 Jan 2020 14:26:58 +0100

boost1.71 (1.71.0-3) unstable; urgency=medium

  [ Giovanni Mascellani ]
  * Update autopkgtest dependencies to 1.71.
  * Fix some missing dependencies between -dev packages, found thanks to
    autopkgtest.
  * Remove signals from autopkgtest.
  * Cleanup Debian patches.

  [ Dimitri John Ledkov ]
  * Cherrypick upstream patch to enable context on s390x. LP: #1694926

 -- Giovanni Mascellani <gio@debian.org>  Fri, 03 Jan 2020 11:11:45 +0100

boost1.71 (1.71.0-2) unstable; urgency=medium

  * Enable -context on riscv64 (closes: #947651). Thanks to Aurelien Jarno for
    the patch.
  * Install cmake boost_headers files.

 -- Giovanni Mascellani <gio@debian.org>  Tue, 31 Dec 2019 15:25:01 +0100

boost1.71 (1.71.0-1) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Remove myself from uploaders.
  * Provide and Encode icuabi in libboost-regex shlibdeps. This de-couples
    boost & icu transitions.
  * Fix debian/watch to point at dl.bintray.com
  * Drop py2 builds. (Closes: #936227)
  * Drop Debian-only compat py library symlinks. (Closes: #914513)
  * Ship cmake files, hopefully they are right.
  * Enable documentation index.

  [ Giovanni Mascellani ]
  * Add -contract as dependency of -dev-all.
  * Update to new upstream release 1.71.0.
    + Acknowledge removal of signals library.
    + Tweak build script accordingly.

